using Terraria;
using Terraria.ID;
using Terraria.ModLoader;

namespace SlimeBiome.Textures.Items.Tiles
{
	public class SlimeCrate : ModItem
	{
		public override void SetStaticDefaults()
		{
			DisplayName.SetDefault("Slime Crate");
			Tooltip.SetDefault("<right> to open");
		}

		public override void SetDefaults()
		{
			item.width = 20;
			item.height = 20;
			item.maxStack = 99;
			item.rare = 2;
			item.useTurn = true;
			item.autoReuse = true;
			item.useAnimation = 15;
			item.useTime = 10;
			item.useStyle = 1;
			item.consumable = true;
			item.value = 10000;
			item.createTile = mod.TileType("SlimeCrate");
		}

		public override bool CanRightClick()
		{
			return true;
		}

		public override void RightClick(Player player)
		{
			int RandomItem = Main.rand.Next(5);
			if (RandomItem == 0)
			{
				player.QuickSpawnItem(mod.ItemType("GelThrower"), 1);
			}
			if (RandomItem == 1)
			{
				player.QuickSpawnItem(mod.ItemType("SolidifierTop"), 1);
			}
			if (RandomItem == 2)
			{
				player.QuickSpawnItem(mod.ItemType("BookOfSlimesI"), 1);
			}
			if (RandomItem == 3)
			{
				player.QuickSpawnItem(mod.ItemType("SlimeBall"), 1);
			}
			if (RandomItem == 4)
			{
				player.QuickSpawnItem(mod.ItemType("QuickSlimeSword"), 1);
			}
			int hardmodeBarRate = 4;
			if (Main.hardMode == true)
			{
				hardmodeBarRate = 18;
			}
			if (Main.rand.Next(4) == 0)
			{
				int RandomSecondaryItem = Main.rand.Next(6);
				if (RandomSecondaryItem == 0)
				{
					player.QuickSpawnItem(ItemID.IronBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 1)
				{
					player.QuickSpawnItem(ItemID.LeadBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 2)
				{
					player.QuickSpawnItem(ItemID.SilverBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 3)
				{
					player.QuickSpawnItem(ItemID.TungstenBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 4)
				{
					player.QuickSpawnItem(ItemID.GoldBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 5)
				{
					player.QuickSpawnItem(ItemID.PlatinumBar, Main.rand.Next(10, 20));
				}
			}
			if (Main.hardMode == true && Main.rand.Next(9) == 0)
			{
				int RandomSecondaryItem = Main.rand.Next(6);
				if (RandomSecondaryItem == 0)
				{
					player.QuickSpawnItem(ItemID.CobaltBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 1)
				{
					player.QuickSpawnItem(ItemID.MythrilBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 2)
				{
					player.QuickSpawnItem(ItemID.AdamantiteBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 3)
				{
					player.QuickSpawnItem(ItemID.PalladiumBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 4)
				{
					player.QuickSpawnItem(ItemID.OrichalcumBar, Main.rand.Next(10, 20));
				}
				if (RandomSecondaryItem == 5)
				{
					player.QuickSpawnItem(ItemID.TitaniumBar, Main.rand.Next(10, 20));
				}
			}
			if (Main.rand.Next(4) == 0)
			{
				int RandomSecondaryItem = Main.rand.Next(6);
				if (RandomSecondaryItem == 0)
				{
					player.QuickSpawnItem(ItemID.ObsidianSkinPotion, Main.rand.Next(2, 4));
				}
				if (RandomSecondaryItem == 1)
				{
					player.QuickSpawnItem(ItemID.SpelunkerPotion, Main.rand.Next(2, 4));
				}
				if (RandomSecondaryItem == 2)
				{
					player.QuickSpawnItem(ItemID.HunterPotion, Main.rand.Next(2, 4));
				}
				if (RandomSecondaryItem == 3)
				{
					player.QuickSpawnItem(ItemID.GravitationPotion, Main.rand.Next(2, 4));
				}
				if (RandomSecondaryItem == 4)
				{
					player.QuickSpawnItem(ItemID.MiningPotion, Main.rand.Next(2, 4));
				}
				if (RandomSecondaryItem == 5)
				{
					player.QuickSpawnItem(ItemID.HeartreachPotion, Main.rand.Next(2, 4));
				}
			}
			if (Main.rand.Next(2) == 0)
			{
				int RandomSecondaryItem = Main.rand.Next(2);
				if (RandomSecondaryItem == 0)
				{
					player.QuickSpawnItem(ItemID.LesserHealingPotion, Main.rand.Next(5, 17));
				}
				if (RandomSecondaryItem == 1)
				{
					player.QuickSpawnItem(ItemID.LesserManaPotion, Main.rand.Next(5, 17));
				}
			}
			if (Main.rand.Next(3) <= 1)
			{
				player.QuickSpawnItem(ItemID.JourneymanBait, Main.rand.Next(1, 4));
			}
			else if (Main.rand.Next(3) == 2)
			{
				player.QuickSpawnItem(ItemID.MasterBait, Main.rand.Next(1, 4));
			}
			if (Main.rand.Next(4) == 0)
			{
				player.QuickSpawnItem(ItemID.GoldCoin, Main.rand.Next(5, 12));
			}
		}
	}
}
