using System.IO;
using System.Collections.Generic;
//using System.Linq;
using Terraria;
using Terraria.ID;
//using Terraria.Localization;
using Terraria.ModLoader;
using Terraria.World.Generation;
using Microsoft.Xna.Framework;
using Terraria.GameContent.Generation;
using Terraria.ModLoader.IO;

namespace SlimeBiome
{
    public class SlimeBiomeWorld : ModWorld
    {
 		public static int ZoneSlimeBiome = 0;
 		public static int ZoneSlimeBlueBiome = 0;
 		public static int ZoneSlimeSnowBiome = 0;
 		public static int ZoneSlimePurpleBiome = 0;
 		public static int ZoneSlimeDesertBiome = 0;
 		public static int ZoneSlimeGlowBiome = 0;
 		public static int ZoneSlimeJungleBiome = 0;
 		public static int ZoneSlimeOasisBiome = 0;
 		public static int TownSlimeX = 0;
 		public static int TownSlimeY = 0;
 		public static bool SavedTownSlime = false;

		public override void Initialize()
		{
 			TownSlimeX = 0;
 			TownSlimeY = 0;
 			SavedTownSlime = false;
		}

		public override TagCompound Save()
		{
			var point = new List<string>();
			//var saved = new List<string>();
			/*if (downedAbomination)* */point.Add("TownSlimeX");
			/*if (downedPuritySpirit)* */point.Add("TownSlimeY");
			//if (SavedTownSlime) saved.Add("SavedTownSlime");

			return new TagCompound {
				{"point", point}//,
				//{"saved", saved}
			};
		}

		/*public override void Load(TagCompound tag)
		{
			var point = tag.GetList<string>("point");
			TownSlimeX = point.Contains("TownSlimeX");
			TownSlimeY = point.Contains("TownSlimeY");
		}*/

        public override void ModifyWorldGenTasks(List<GenPass> tasks, ref float totalWeight)
        {
			int ThirdDown = Main.maxTilesY / 3;
			int TwoThirdsDown = ThirdDown + ThirdDown;
			int startPositionX = WorldGen.genRand.Next(0, Main.maxTilesX);
			int startPositionY = TwoThirdsDown;
			int size = Main.maxTilesX / 25;
			int sizeEye = size / 4;
			int sizeMini = size / 4;
			int sizeThird = size / 3;
			int sizeHalf = size / 2;
			int sizeTwoThirds = sizeThird + sizeThird;
			int sizeQuarter = size / 4;
			int sizeDouble = size * 2;
			//int ringMiniBiomeStart = sizeQuarter * 3;
			int startMiniX1 = startPositionX + Main.rand.Next(size) - sizeHalf;
			int startMiniX2 = startPositionX + Main.rand.Next(size) - sizeHalf;
			int startMiniX3 = startPositionX + Main.rand.Next(size) - sizeHalf;
			int startMiniY1 = startPositionY + Main.rand.Next(size) - sizeHalf;
			int startMiniY2 = startPositionY + Main.rand.Next(size) - sizeHalf;
			int startMiniY3 = startPositionY + Main.rand.Next(size) - sizeHalf;
			int SlimeChestShrineCount = size * 2;
			int SlimeCaveCount = size / 3;
			int SlimestoneAmount = size * 20;
			int SlimeOreAmount1 = size * 150;
			int SlimeOreAmount2 = size * 75;
			int sizeMinCave = 1;
			int sizeMaxCave = 10;
			int EyeGroundLevelPartial1 = sizeEye / 2;
			int EyeGroundLevelPartial2 = sizeEye / 4;
			int EyeGroundLevel = EyeGroundLevelPartial1 + EyeGroundLevelPartial2;

			TownSlimeX = startPositionX;// + Main.rand.Next(size) - sizeHalf;
			TownSlimeY = startPositionY;// + Main.rand.Next(size) - sizeHalf;
			
			/*int startMiniX1 = 0;
			int startMiniX2 = 0;
			int startMiniX3 = 0;
			int startMiniY1 = 0;
			int startMiniY2 = 0;
			int startMiniY3 = 0;

			/*for (int x = startPositionX - ringMiniBiomeStart; x <= startPositionX + ringMiniBiomeStart; x++)
			{
					for (int y = startPositionY - ringMiniBiomeStart; y <= startPositionY + ringMiniBiomeStart; y++)
					{
						if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) <= ringMiniBiomeStart)
						{
							if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) >= ringMiniBiomeStart - 1)
							{
								/*int OneX = Main.rand.Next(x);
								int OneY = Main.rand.Next(y);
								startMiniX1 = OneX & OneY;
								startMiniX2 = OneX & OneY;
								startMiniX3 = OneX & OneY;
								startMiniY1 = OneX & OneY;
								startMiniY2 = OneX & OneY;
								startMiniY3 = OneX & OneY;*
								if (Main.rand.Next(50) == 1)
								{
									if (Main.rand.Next(6) == 1)
									{
										startMiniX1 = x;
									}
									else if (Main.rand.Next(5) == 1)
									{
										startMiniX2 = x;
									}
									else if (Main.rand.Next(4) == 1)
									{
										startMiniX3 = x;
									}
									else if (Main.rand.Next(3) == 1)
									{
										startMiniY1 = y;
									}
									else if (Main.rand.Next(2) == 1)
									{
										startMiniY2 = y;
									}
									startMiniY3 = y;
								}
							}
						}
					}
			}*/

            int genIndex = tasks.FindIndex(genpass => genpass.Name.Equals("Silt")); 
            if (genIndex == -1)
            {
                return;
            }
            tasks.Insert(genIndex + 1, new PassLegacy("Slime Biome", delegate (GenerationProgress progress)
            {
                progress.Message = "Slimes are taking over the world";

				for (int x = startPositionX - size; x <= startPositionX + size; x++)
				{
					for (int y = startPositionY - size; y <= startPositionY + size; y++)
					{
						if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) <= size)
						{
							Main.tile[x, y].wall = (ushort)mod.WallType("UnsafeSlimedirtWall");
							//if (Main.tile[x, y].type != TileID.Copper && Main.tile[x, y].type != TileID.Iron && Main.tile[x, y].type != TileID.Silver && Main.tile[x, y].type != TileID.Gold && Main.tile[x, y].type != TileID.Tin && Main.tile[x, y].type != TileID.Lead && Main.tile[x, y].type != TileID.Tungsten && Main.tile[x, y].type != TileID.Platinum)
							//{
								Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtBlock");
							//}
							WorldGen.PlaceTile(x, y, (ushort)mod.TileType("SlimedirtBlock"));
						}
					}
				}
				for (int k3 = 0; k3 < SlimeCaveCount; k3++)
				{
					int startX = startPositionX + Main.rand.Next(sizeDouble) - size;
					int startY = startPositionY + Main.rand.Next(sizeDouble) - size;
					int sizeCave = Main.rand.Next(sizeMinCave, sizeMaxCave);
					for (int x = startX - sizeCave; x <= startX + sizeCave; x++)
					{
						for (int y = startY - sizeCave; y <= startY + sizeCave; y++)
						{
							if (Vector2.Distance(new Vector2(startX, startY), new Vector2(x, y)) <= sizeCave)
							{
								if (Main.tile[x, y].type == mod.TileType("SlimedirtBlock"))
								{
									WorldGen.KillTile(x, y, false, false, true);
								}
							}
						}
					}
				}
				/*for (int x = startPositionX - sizeEye + 1; x <= startPositionX + sizeEye + 1; x++)
				{
					for (int y = startPositionY - sizeEye + 1; y <= startPositionY + sizeEye + 1; y++)
					{
						if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) <= sizeEye + 1)
						{
							if (Main.tile[x, y].type == mod.TileType("SlimedirtBlock"))
							{
								Main.tile[x, y].type = (ushort)mod.TileType("SlimeGrassBlock");
							}
						}
					}
				}*/
				for (int x = startPositionX - sizeEye; x <= startPositionX + sizeEye; x++)
				{
					for (int y = startPositionY - sizeEye; y <= startPositionY + sizeEye; y++)
					{
						if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) <= sizeEye)
						{
							WorldGen.KillTile(x, y, false, false, true);
							//if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) >= 8/*startPositionY + EyeGroundLevel*/)
							if (y >= startPositionY + EyeGroundLevel)
							{
								WorldGen.PlaceTile(x, y, (ushort)mod.TileType("SlimedirtBlock"));
							}
							if (y < startPositionY + EyeGroundLevel)
							{
								WorldGen.KillWall(x, y, false);
							}
						}
					}
				}
				for (int k = 0; k < SlimestoneAmount; k++)
				{
					int positionX = WorldGen.genRand.Next(0, Main.maxTilesX);
					int positionY = WorldGen.genRand.Next(0, Main.maxTilesY);
					if (Main.tile[positionX, positionY].type == mod.TileType("SlimedirtBlock"))
					{
						WorldGen.TileRunner(positionX, positionY, WorldGen.genRand.Next(2, 32), WorldGen.genRand.Next(2, 8), (ushort)mod.TileType("SlimestoneBlock"), false, 0f, 0f, false, true);
					}
				}
				for (int k = 0; k < SlimeOreAmount1; k++)
				{
					int positionX = WorldGen.genRand.Next(0, Main.maxTilesX);
					int positionY = WorldGen.genRand.Next(0, Main.maxTilesY);
					if (Main.tile[positionX, positionY].type == mod.TileType("SlimestoneBlock"))
					{
						WorldGen.TileRunner(positionX, positionY, WorldGen.genRand.Next(3, 10), WorldGen.genRand.Next(3, 10), (ushort)mod.TileType("CrystalizedSlime"), false, 0f, 0f, false, true);
					}
				}
				for (int k = 0; k < SlimeOreAmount2; k++)
				{
					int positionX = WorldGen.genRand.Next(0, Main.maxTilesX);
					int positionY = WorldGen.genRand.Next(0, Main.maxTilesY);
					if (Main.tile[positionX, positionY].type == mod.TileType("SlimestoneBlock"))
					{
						WorldGen.TileRunner(positionX, positionY, WorldGen.genRand.Next(1, 3), WorldGen.genRand.Next(1, 3), (ushort)mod.TileType("CrystalizedPinkSlime"), false, 0f, 0f, false, true);
					}
				}
				if (true)
				{
					int positionX = WorldGen.genRand.Next(0, Main.maxTilesX);
					int positionY = WorldGen.genRand.Next(0, Main.maxTilesY);
					if (Main.tile[positionX, positionY].type == mod.TileType("CrystalizedSlime"))
					{
						if (Main.rand.Next(10) == 1)
						{
							Main.tile[positionX, positionY].type = (ushort)mod.TileType("SlimeAmbor");
						}
					}
					/*if (Main.tile[positionX, positionY].type == mod.TileType("SlimestoneBlock"))
					{
						if (Main.rand.Next(1) == 1)
						{
							Main.tile[positionX, positionY].type = (ushort)mod.TileType("SlimelingOre");
						}
					}*/
				}

				if (Main.rand.Next(2) == 1)
				{
					for (int x = startMiniX1 - sizeMini; x <= startMiniX1 + sizeMini; x++)
					{
						for (int y = startMiniY1 - sizeMini; y <= startMiniY1 + sizeMini; y++)
						{
							if (Vector2.Distance(new Vector2(startMiniX1, startMiniY1), new Vector2(x, y)) <= sizeMini)
							{
								if (Main.tile[x, y].wall == (ushort)mod.WallType("UnsafeSlimedirtWall"))
								{
									Main.tile[x, y].wall = (ushort)mod.WallType("UnsafeSlimedirtBlueWall");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimedirtBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtBlue");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimestoneBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimestoneBlue");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("CrystalizedSlime"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("CrystalizedSlimeBlue");
								}
							}
						}
					}
				}
				else
				{
					for (int x = startMiniX1 - sizeMini; x <= startMiniX1 + sizeMini; x++)
					{
						for (int y = startMiniY1 - sizeMini; y <= startMiniY1 + sizeMini; y++)
						{
							if (Vector2.Distance(new Vector2(startMiniX1, startMiniY1), new Vector2(x, y)) <= sizeMini)
							{
								if (Main.tile[x, y].wall == (ushort)mod.WallType("UnsafeSlimedirtWall"))
								{
									Main.tile[x, y].wall = (ushort)mod.WallType("UnsafeSlimedirtPurpleWall");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimedirtBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtPurple");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimestoneBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimestonePurple");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("CrystalizedSlime"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("CrystalizedSlimePurple");
								}
							}
						}
					}
				}
				if (Main.rand.Next(2) == 1)
				{
					for (int x = startMiniX2 - sizeMini; x <= startMiniX2 + sizeMini; x++)
					{
						for (int y = startMiniY2 - sizeMini; y <= startMiniY2 + sizeMini; y++)
						{
							if (Vector2.Distance(new Vector2(startMiniX2, startMiniY2), new Vector2(x, y)) <= sizeMini)
							{
								if (Main.tile[x, y].wall == (ushort)mod.WallType("UnsafeSlimedirtWall"))
								{
									Main.tile[x, y].wall = (ushort)mod.WallType("UnsafeSlimedirtSnowWall");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimedirtBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtSnow");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimestoneBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimestoneSnow");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("CrystalizedSlime"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("CrystalizedSlimeSnow");
								}
							}
						}
					}
				}
				else
				{
					for (int x = startMiniX2 - sizeMini; x <= startMiniX2 + sizeMini; x++)
					{
						for (int y = startMiniY2 - sizeMini; y <= startMiniY2 + sizeMini; y++)
						{
							if (Vector2.Distance(new Vector2(startMiniX2, startMiniY2), new Vector2(x, y)) <= sizeMini)
							{
								if (Main.tile[x, y].wall == (ushort)mod.WallType("UnsafeSlimedirtWall"))
								{
									Main.tile[x, y].wall = (ushort)mod.WallType("UnsafeSlimedirtDesertWall");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimedirtBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtDesert");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimestoneBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimestoneDesert");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("CrystalizedSlime"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("CrystalizedSlimeDesert");
								}
							}
						}
					}
				}
				if (Main.rand.Next(2) == 1)
				{
					for (int x = startMiniX3 - sizeMini; x <= startMiniX3 + sizeMini; x++)
					{
						for (int y = startMiniY3 - sizeMini; y <= startMiniY3 + sizeMini; y++)
						{
							if (Vector2.Distance(new Vector2(startMiniX3, startMiniY3), new Vector2(x, y)) <= sizeMini)
							{
								if (Main.tile[x, y].wall == (ushort)mod.WallType("UnsafeSlimedirtWall"))
								{
									Main.tile[x, y].wall = (ushort)mod.WallType("UnsafeSlimedirtGlowWall");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimedirtBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtGlow");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimestoneBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimestoneGlow");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("CrystalizedSlime"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("CrystalizedSlimeGlow");
								}
							}
						}
					}
				}
				else
				{
					for (int x = startMiniX3 - sizeMini; x <= startMiniX3 + sizeMini; x++)
					{
						for (int y = startMiniY3 - sizeMini; y <= startMiniY3 + sizeMini; y++)
						{
							if (Vector2.Distance(new Vector2(startMiniX3, startMiniY3), new Vector2(x, y)) <= sizeMini)
							{
								if (Main.tile[x, y].wall == (ushort)mod.WallType("UnsafeSlimedirtWall"))
								{
									Main.tile[x, y].wall = (ushort)mod.WallType("UnsafeSlimedirtJungleWall");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimedirtBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtJungle");
								}
								if (Main.tile[x, y].type == (ushort)mod.TileType("SlimestoneBlock"))
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimestoneJungle");
								}
							}
						}
					}
				}
			}));
            int genIndex2 = tasks.FindIndex(genpass => genpass.Name.Equals("Jungle Trees")); 
            if (genIndex2 == -1)
            {
                return;
            }
            tasks.Insert(genIndex2 + 1, new PassLegacy("Slime Structures", delegate (GenerationProgress progress)
            {
                progress.Message = "Colonizing Slimes";
				for (int k3 = 0; k3 < SlimeChestShrineCount; k3++)
				{
					int positionX = WorldGen.genRand.Next(0, Main.maxTilesX);
					int positionY = WorldGen.genRand.Next(0, Main.maxTilesY);
					if (Main.tile[positionX, positionY].type == mod.TileType("SlimedirtBlock") || Main.tile[positionX, positionY].type == mod.TileType("SlimedirtBlue") || Main.tile[positionX, positionY].type == mod.TileType("SlimedirtPurple") || Main.tile[positionX, positionY].type == mod.TileType("SlimedirtSnow") || Main.tile[positionX, positionY].type == mod.TileType("SlimedirtDesert") || Main.tile[positionX, positionY].type == mod.TileType("SlimedirtGlow") || Main.tile[positionX, positionY].type == mod.TileType("SlimedirtJungle"))
					{
						for (int k = 0; k < 10; k++)
						{
							for (int l = 0; l < 7; l++)
							{
								WorldGen.KillTile(positionX - k, positionY - l + 1, false, false, true);
							}
						}
						for (int k = 0; k < 10; k++)
						{
							for (int l = 0; l < 1; l++)
							{
								WorldGen.PlaceTile(positionX - k, positionY + 1, (ushort)mod.TileType("SlimeWood"));
							}
						}
						for (int k = 0; k < 10; k++)
						{
							for (int l = 0; l < 1; l++)
							{
								WorldGen.PlaceTile(positionX - k, positionY - 4, (ushort)mod.TileType("SlimeWood"));
							}
						}
						for (int k = 0; k < 12; k++)
						{
							for (int l = 0; l < 1; l++)
							{
								WorldGen.KillTile(positionX - k + 1, positionY - 5, false, false, true);
								WorldGen.PlaceTile(positionX - k + 1, positionY - 5, (ushort)mod.TileType("SlimeShingles"));
							}
						}
						for (int k = 0; k < 10; k++)
						{
							for (int l = 0; l < 1; l++)
							{
								WorldGen.KillTile(positionX - k, positionY - 6, false, false, true);
								WorldGen.PlaceTile(positionX - k, positionY - 6, (ushort)mod.TileType("SlimeShingles"));
							}
						}
						for (int k = 0; k < 8; k++)
						{
							for (int l = 0; l < 1; l++)
							{
								WorldGen.KillTile(positionX - k - 1, positionY - l - 7, false, false, true);
								WorldGen.PlaceTile(positionX - k - 1, positionY - l - 7, (ushort)mod.TileType("SlimeShingles"));
							}
						}
						for (int k2 = 0; k2 < 8; k2++)
						{
							for (int l = 0; l < 4; l++)
							{
								WorldGen.KillWall(positionX - k2 - 1, positionY - l, false);
								WorldGen.PlaceWall(positionX - k2 - 1, positionY - l, (ushort)mod.WallType("UnsafeSlimeWoodWall"));
							}
						}
						for (int l = 0; l < 15; l++)
						{
							for (int k = 0; k < 3; k++)
							{
								WorldGen.PlaceTile(positionX, positionY - 3, (ushort)mod.TileType("SlimeWood"));
								WorldGen.PlaceTile(positionX - 9, positionY - 3, (ushort)mod.TileType("SlimeWood"));
								WorldGen.PlaceTile(positionX - 1, positionY - 3, (ushort)mod.TileType("SlimeTorch"));
								WorldGen.PlaceTile(positionX - 8, positionY - 3, (ushort)mod.TileType("SlimeTorch"));
								WorldGen.PlaceChest(positionX - 5, positionY, (ushort)mod.TileType("SlimeChest"), false, 0);
							}
						}
					}
				}
			}));
            int genIndex3 = tasks.FindIndex(genpass => genpass.Name.Equals("Micro Biomes")); 
            if (genIndex3 == -1)
            {
                return;
            }
            tasks.Insert(genIndex3 + 1, new PassLegacy("Slime Biome Cleanup", delegate (GenerationProgress progress)
            {
                progress.Message = "Perfecting Slimes";
				for (int x = startPositionX - size; x <= startPositionX + size; x++)
				{
					for (int y = startPositionY - size; y <= startPositionY + size; y++)
					{
						if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) <= size)
						{
							if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) >= sizeEye + 1)
							{
								/*if (Main.tile[x, y].type == TileID.Mud)
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtBlock");
								}
								if (Main.tile[x, y].type == TileID.Silt)
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtBlock");
								}
								if (Main.tile[x, y].type == TileID.LivingMahogany)
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtBlock");
								}
								if (Main.tile[x, y].type == TileID.LivingMahoganyLeaves)
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimedirtBlock");
								}*/
							}
						}
					}
				}
				for (int x = startPositionX - sizeEye; x <= startPositionX + sizeEye; x++)
				{
					for (int y = startPositionY - sizeEye; y <= startPositionY + sizeEye; y++)
					{
						if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) <= sizeEye)
						{
							Main.tile[x, y].liquid = 0;
							if (Main.tile[x, y].active())
							{
								//Main.tile[x, y].liquid = 100;
								if (Main.rand.Next(20) == 0)
								{
									WorldGen.KillTile(x, y, false, false, true);
								}
							}
							if (Main.tile[x, y].type == TileID.Obsidian)
							{
								WorldGen.KillTile(x, y, false, false, true);
							}
						}
					}
				}
				/*for (int x = TownSlimeX - size; x <= TownSlimeX + size; x++)
				{
					for (int y = TownSlimeY - size; y <= TownSlimeY + size; y++)
					{
						if (Vector2.Distance(new Vector2(TownSlimeX, TownSlimeY), new Vector2(x, y)) <= size)
						{*/
							//if (Main.tile[TownSlimeX, TownSlimeY].wall == (ushort)mod.WallType("UnsafeSlimedirtWall"))
							//{
								//Main.tile[TownSlimeX, TownSlimeY].wall = (ushort)mod.WallType("UnsafeSlimedirtBlueWall");
								//Main.tile[TownSlimeX, TownSlimeY].type = (ushort)mod.TileType("SlimeWood");
								//WorldGen.PlaceTile(TownSlimeX, TownSlimeY, (ushort)mod.TileType("SlimeWood"));
							//}
					//	}
					//}
				//}
				//main.tile[TownSlimeX, TownSlimeY] = TileID.PearlstoneBrick;*/
				for (int k = 0; k < Main.maxTilesX; k++)
				{
					for (int i = 0; i < Main.maxTilesY; i++)
					{
						if (Main.tile[k, i].type == mod.TileType("SlimestoneBlock"))
						{
							if (Main.tile[k + 1, i].active() && Main.tile[k, i - 1].active() && Main.tile[k - 1, i].active() && Main.tile[k, i + 1].active() && Main.tile[k + 1, i + 1].active() && Main.tile[k - 1, i - 1].active() && Main.tile[k - 1, i + 1].active() && Main.tile[k + 1, i - 1].active())
							{
							}
							else
							{
								Main.tile[k, i].type = (ushort)mod.TileType("SlimedirtBlock");
							}
						}
						if (Main.tile[k, i].type == mod.TileType("SlimestoneBlue"))
						{
							if (Main.tile[k + 1, i].active() && Main.tile[k, i - 1].active() && Main.tile[k - 1, i].active() && Main.tile[k, i + 1].active() && Main.tile[k + 1, i + 1].active() && Main.tile[k - 1, i - 1].active() && Main.tile[k - 1, i + 1].active() && Main.tile[k + 1, i - 1].active())
							{
							}
							else
							{
								Main.tile[k, i].type = (ushort)mod.TileType("SlimedirtBlue");
							}
						}
						if (Main.tile[k, i].type == mod.TileType("SlimestonePurple"))
						{
							if (Main.tile[k + 1, i].active() && Main.tile[k, i - 1].active() && Main.tile[k - 1, i].active() && Main.tile[k, i + 1].active() && Main.tile[k + 1, i + 1].active() && Main.tile[k - 1, i - 1].active() && Main.tile[k - 1, i + 1].active() && Main.tile[k + 1, i - 1].active())
							{
							}
							else
							{
								Main.tile[k, i].type = (ushort)mod.TileType("SlimedirtPurple");
							}
						}
						if (Main.tile[k, i].type == mod.TileType("SlimestoneSnow"))
						{
							if (Main.tile[k + 1, i].active() && Main.tile[k, i - 1].active() && Main.tile[k - 1, i].active() && Main.tile[k, i + 1].active() && Main.tile[k + 1, i + 1].active() && Main.tile[k - 1, i - 1].active() && Main.tile[k - 1, i + 1].active() && Main.tile[k + 1, i - 1].active())
							{
							}
							else
							{
								Main.tile[k, i].type = (ushort)mod.TileType("SlimedirtSnow");
							}
						}
						if (Main.tile[k, i].type == mod.TileType("SlimestoneDesert"))
						{
							if (Main.tile[k + 1, i].active() && Main.tile[k, i - 1].active() && Main.tile[k - 1, i].active() && Main.tile[k, i + 1].active() && Main.tile[k + 1, i + 1].active() && Main.tile[k - 1, i - 1].active() && Main.tile[k - 1, i + 1].active() && Main.tile[k + 1, i - 1].active())
							{
							}
							else
							{
								Main.tile[k, i].type = (ushort)mod.TileType("SlimedirtDesert");
							}
						}
						if (Main.tile[k, i].type == mod.TileType("SlimestoneGlow"))
						{
							if (Main.tile[k + 1, i].active() && Main.tile[k, i - 1].active() && Main.tile[k - 1, i].active() && Main.tile[k, i + 1].active() && Main.tile[k + 1, i + 1].active() && Main.tile[k - 1, i - 1].active() && Main.tile[k - 1, i + 1].active() && Main.tile[k + 1, i - 1].active())
							{
							}
							else
							{
								Main.tile[k, i].type = (ushort)mod.TileType("SlimedirtGlow");
							}
						}
						if (Main.tile[k, i].type == mod.TileType("SlimedirtJungle"))
						{
							if (Main.tile[k + 1, i].active() && Main.tile[k, i - 1].active() && Main.tile[k - 1, i].active() && Main.tile[k, i + 1].active() && Main.tile[k + 1, i + 1].active() && Main.tile[k - 1, i - 1].active() && Main.tile[k - 1, i + 1].active() && Main.tile[k + 1, i - 1].active())
							{
							}
							else
							{
								Main.tile[k, i].type = (ushort)mod.TileType("SlimeGrassJungle");
							}
						}
						/*if (Main.tile[k, i].wall == mod.WallType("UnsafeSlimedirtWall") || Main.tile[k, i].wall == mod.WallType("UnsafeSlimedirtBlueWall") || Main.tile[k, i].wall == mod.WallType("UnsafeSlimedirtPurpleWall") || Main.tile[k, i].wall == mod.WallType("UnsafeSlimedirtSnowWall") || Main.tile[k, i].wall == mod.WallType("UnsafeSlimedirtDesertWall") || Main.tile[k, i].wall == mod.WallType("UnsafeSlimedirtGlowWall") || Main.tile[k, i].wall == mod.WallType("UnsafeSlimedirtJungleWall"))
						{
							if (Main.tile[k, i + 1].wall == 0 || Main.tile[k, i - 1].wall == 0 || Main.tile[k + 1, i].wall == 0 || Main.tile[k - 1, i].wall == 0 || Main.tile[k + 1, i + 1].wall == 0 || Main.tile[k - 1, i - 1].wall == 0 || Main.tile[k + 1, i + 1].wall == 0 || Main.tile[k - 1, i - 1].wall == 0)
							{
								Main.tile[k, i].wall = 0;
							}
						}*/
					}
				}
				for (int x = startPositionX - sizeEye + 1; x <= startPositionX + sizeEye + 1; x++)
				{
					for (int y = startPositionY - sizeEye + 1; y <= startPositionY + sizeEye + 1; y++)
					{
						if (Vector2.Distance(new Vector2(startPositionX, startPositionY), new Vector2(x, y)) <= sizeEye + 1)
						{
							if (Main.tile[x, y].type == mod.TileType("SlimedirtBlock") || Main.tile[x, y].type == mod.TileType("SlimedirtBlue") || Main.tile[x, y].type == mod.TileType("SlimedirtPurple") || Main.tile[x, y].type == mod.TileType("SlimedirtSnow") || Main.tile[x, y].type == mod.TileType("SlimedirtDesert") || Main.tile[x, y].type == mod.TileType("SlimedirtGlow") || Main.tile[x, y].type == mod.TileType("SlimedirtJungle"))
							{
								if (Main.tile[x + 1, y].active() && Main.tile[x, y - 1].active() && Main.tile[x - 1, y].active() && Main.tile[x, y + 1].active() && Main.tile[x + 1, y + 1].active() && Main.tile[x - 1, y - 1].active() && Main.tile[x - 1, y + 1].active() && Main.tile[x + 1, y - 1].active())
								{
								}
								else
								{
									Main.tile[x, y].type = (ushort)mod.TileType("SlimeGrassBlock");
								}
							}
						}
					}
				}
			}));
		}

		public override void PostWorldGen()
		{
			int[] itemsToPlaceInSlimeChests = new int[] { mod.ItemType("GelThrower"), mod.ItemType("SolidifierTop"), mod.ItemType("BookOfSlimesI"), mod.ItemType("SlimeBall"), mod.ItemType("QuickSlimeSword") };
			int itemsToPlaceInSlimeChestsChoice = 0;
			for (int chestIndex = 0; chestIndex < 1000; chestIndex++)
			{
				Chest chest = Main.chest[chestIndex];
				// If you look at the sprite for Chests by extracting Tiles_21.xnb, you'll see that the 12th chest is the Ice Chest. Since we are counting from 0, this is where 11 comes from. 36 comes from the width of each tile including padding. 
				if (chest != null && Main.tile[chest.x, chest.y].type == mod.TileType("SlimeChest"))
				{
					for (int inventoryIndex = 0; inventoryIndex < 40; inventoryIndex++)
					{
						if (chest.item[inventoryIndex].type == 0)
						{
							//chest.item[inventoryIndex].SetDefaults(itemsToPlaceInSlimeChests[itemsToPlaceInSlimeChestsChoice]);
							//itemsToPlaceInSlimeChestsChoice = (itemsToPlaceInSlimeChestsChoice + 1) % itemsToPlaceInSlimeChests.Length;
							chest.item[inventoryIndex].SetDefaults(Main.rand.Next(itemsToPlaceInSlimeChests));
							break;
						}
					}
				}
			}
		}

		public override void TileCountsAvailable(int[] tileCounts)
        {
            ZoneSlimeBiome = tileCounts[mod.TileType("SlimestoneBlock")];
            ZoneSlimeBiome = tileCounts[mod.TileType("SlimedirtBlock")];
            ZoneSlimeBlueBiome = tileCounts[mod.TileType("SlimestoneBlue")];
            ZoneSlimeBlueBiome = tileCounts[mod.TileType("SlimedirtBlue")];
            ZoneSlimeSnowBiome = tileCounts[mod.TileType("SlimestoneSnow")];
            ZoneSlimeSnowBiome = tileCounts[mod.TileType("SlimedirtSnow")];
            ZoneSlimePurpleBiome = tileCounts[mod.TileType("SlimestonePurple")];
            ZoneSlimePurpleBiome = tileCounts[mod.TileType("SlimedirtPurple")];
            ZoneSlimeDesertBiome = tileCounts[mod.TileType("SlimestoneDesert")];
            ZoneSlimeDesertBiome = tileCounts[mod.TileType("SlimedirtDesert")];
            ZoneSlimeGlowBiome = tileCounts[mod.TileType("SlimestoneGlow")];
            ZoneSlimeGlowBiome = tileCounts[mod.TileType("SlimedirtGlow")];
            ZoneSlimeJungleBiome = tileCounts[mod.TileType("SlimestoneJungle")];
            ZoneSlimeJungleBiome = tileCounts[mod.TileType("SlimedirtJungle")];
            ZoneSlimeOasisBiome = tileCounts[mod.TileType("SlimeGrassBlock")];
        }
    }
}
