using Terraria;
using Terraria.ID;
using Terraria.ModLoader;

namespace SlimeBiome.Textures.Items.Weapons
{
	public class GelBlaster : ModItem
	{
		public override void SetStaticDefaults()
		{
			Tooltip.SetDefault("Name is mostly marketing.");
		}

		public override void SetDefaults()
		{
			item.damage = 12;
			item.ranged = true;
			item.width = 32;
			item.height = 32;
			item.useTime = 30;
			item.useAnimation = 30;
			item.useStyle = 5;
			item.noMelee = true;
			item.knockBack = 2.3f;
			item.value = 100000;
			item.UseSound = SoundID.Item11;
			item.autoReuse = true;
			item.shoot = 10;
			item.shootSpeed = 7.1f;
			item.useAmmo = mod.ItemType("GelShot");
		}
	}
	public class GelShot : ModItem
	{
		public override void SetStaticDefaults()
		{
			Tooltip.SetDefault("Little Gel used for some weapons"+"Is also an weapon in itself/2 in 1");
		}

		public override void SetDefaults()
		{
			item.damage = 4;
			item.ranged = true;
			item.width = 20;
			item.height = 20;
			item.maxStack = 999;
			item.consumable = true;
			item.knockBack = 1.5f;
			item.value = 40;
			item.shoot = mod.ProjectileType("GelShot");
			item.shootSpeed = 1.5f;
			item.ammo = item.type;
			item.thrown = true;
            item.useStyle = 1;
			item.useTime = 24;
			item.useAnimation = 24;
            item.noUseGraphic = true;
		}

		public override void AddRecipes()
		{
			ModRecipe recipe = new ModRecipe(mod);
			recipe.AddIngredient(ItemID.Gel, 1);
			recipe.AddTile(mod.TileType("SolidifierPanel"));
			recipe.SetResult(this, 30);
			recipe.AddRecipe();
		}
	}
	public class DenseGelShot : ModItem
	{
		public override void SetStaticDefaults()
		{
			Tooltip.SetDefault("Little Gel used for some weapons"+"Is also an weapon in itself/2 in 1");
		}

		public override void SetDefaults()
		{
			item.damage = 4;
			item.ranged = true;
			item.width = 20;
			item.height = 20;
			item.maxStack = 999;
			item.consumable = true;
			item.knockBack = 1.5f;
			item.value = 60;
			item.shoot = mod.ProjectileType("DenseGelShot");
			item.shootSpeed = 1.5f;
			item.ammo = mod.ItemType("GelShot");
			item.thrown = true;
            item.useStyle = 1;
			item.useTime = 24;
			item.useAnimation = 24;
            item.noUseGraphic = true;
		}
	}
}
